Subject: Re: bug#64310: 29.0.92; pure-GTK warning under Wayland

From: Po Lu <[email-masked]>
Date: Sat, 22 Jul 2023 21:38:47 +0800

Eli Zaretskii <[email-masked]> writes:

> Ping!  Can we make some progress in this issue?
>
>> From: Pankaj Jangid <[email-masked]>
>> Cc: Eli Zaretskii <[email-masked]>,  [email-masked]
>> Date: Thu, 13 Jul 2023 15:00:16 +0530
>> 
>> Po Lu <[email-masked]> writes:
>> 
>> >>> > Pankaj Jangid <[email-masked]> writes:
>> >>> >
>> >>> >> Exec=sh -c "u=\\$(echo \\"\\$1\\" | sed 's/[\\\\\\"]/\\\\\\\\&/g');
>> >>> >> exec emacsclient --alternate-editor= --display=\\"\\$DISPLAY\\"
>> >>> >> --eval \\"(message-mailto \\\\\\"\\$u\\\\\\")\\"" sh %u
>> >>> >
>> >>> > I think this line here is the problem: it will make emacsclient try to
>> >>> > use the Xwayland display.  What happens if you delete the `--display'
>> >>> > argument from this command line?  Emacsclient should be smart enough to
>> >>> > figure out which display to use from the environment alone.
>> >>> 
>> >>> Nope. I removed the "--display=..."  argument from
>> >>> .local/share/emacs/29.0.92/etc/emacsclient-mail.desktop. It did not make
>> >>> any difference.
>> >>> 
>> >
>> > Sorry, I must've missed that reply.  Pankaj, what if you replace
>> > --display="$DISPLAY" with --display="$WAYLAND_DISPLAY"?
>> >
>> 
>> Nothing changes. When there is no default email handler configured
>> i.e. when Firefox is set to ask each time. It shows two options for
>> Emacs - (1) Emacs(Mail, Client) (2) Emacs (Mail). When I select the
>> first one, it shows error that I reported. If I select option (2), Emacs
>> launches without any warning (desired behaviour).
>> 
>> 

I tried to reproduce this myself a few weeks ago, but I guess the line
eater ate my reply.

Unfortunately, the desktop file works as expected.  Are you sure the
emacsclient you've installed corresponds to a PGTK build of Emacs?  If
it's part of an Emacs installation built with another window system,
PGTK-specific code within won't be present, demonstrating symptoms
similar to what you are experiencing.